//
//  ViewController.m
//  roundAnimation
//
//  Created by mac on 16/8/15.
//  Copyright © 2016年 huang. All rights reserved.
//

#import "ViewController.h"

@interface ViewController (){
    
    UIView *pointView;
    UIView *view;
}

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    //外圆
    view = [[UIView alloc] initWithFrame:CGRectMake(50, 300, 100, 100)];
    view.backgroundColor = [UIColor blackColor];
    view.layer.cornerRadius = 50;
    view.layer.borderColor = [UIColor greenColor].CGColor;
    view.layer.borderWidth = 5;
    [self.view addSubview:view];
    //小圆点
    pointView = [[UIView alloc] initWithFrame:CGRectMake(20, 10, 15, 15)];
    pointView.backgroundColor = [UIColor whiteColor];
    pointView.layer.cornerRadius = 7;
    [view addSubview:pointView];
    
}

- (void) touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event {
    
    [self moveAction];
}

- (void) moveAction {
    
    CAKeyframeAnimation *animation = [CAKeyframeAnimation animationWithKeyPath:@"position"];
    
    //path
    CGMutablePathRef path = CGPathCreateMutable();
    //画圆弧
    CGPathAddArc(path, NULL, 50, 50, 35, 0, 2*M_PI, 0);
    
    animation.path = path;
    
    animation.duration = 3;
    
    animation.repeatCount = MAXFLOAT;
    
    [pointView.layer addAnimation:animation forKey:nil];
    
    CAKeyframeAnimation *animation1 = [CAKeyframeAnimation animationWithKeyPath:@"position"];
    
    animation1.duration = 3;
    animation1.repeatCount = MAXFLOAT;
    
    //path
    CGMutablePathRef path1 = CGPathCreateMutable();
    
    CGPathMoveToPoint(path1, NULL, 50, 200);
    
    CGPoint cp = CGPointMake(200, 0);
    CGPoint cp1 = CGPointMake(200, 350);
    CGPoint cp2 = CGPointMake(400, 500);
    
    //绘制贝塞尔曲线
    CGPathAddCurveToPoint(path1, NULL, cp.x, cp.y, cp1.x, cp1.y, cp2.x, cp2.y);
    
    //设置动画的的执行路径
    animation1.path = path1;
    
    //3 添加
    [view.layer addAnimation:animation1 forKey:nil];
    
    

}
@end
